import es, playerlib, popuplib, cfglib, services

config = cfglib.AddonCFG(es.ServerVar('eventscripts_gamedir') + '/cfg/respawnmenu.cfg')
config.text("**************************")
config.text("       Respawn Menu       ")
config.text("**************************")
respawnmenu_command   = config.cvar("respawnmenu_command",   '!respawn', "What admins type to bring menu up")
respawnmenu_announce   = config.cvar("respawnmenu_announce",   1, "Announces who you respawned")


config.write()

# ======================#
#         PUBLIC
# ======================#
info = es.AddonInfo()
info.name     = "Respawn Menu"
info.version  = "1.3"
info.url      = "None"
info.basename = "sic_respawnmenu"
info.author   = "sicman_adrian"
es.ServerVar(info.basename, info.version, info.name).makepublic()

def load():
    setup_auth()
    config.execute()
    if not es.exists('saycommand', respawnmenu_command ):
        es.regsaycmd(respawnmenu_command , 'respawnmenu/respawnmenu')

def unload():
    if es.exists('saycommand', respawnmenu_command):
        es.unregsaycmd(respawnmenu_command)

def respawnmenu():
    userid = es.getcmduserid()
    if isAuthed(userid):
        sic_respawnmenu = popuplib.easymenu('player_list', '_popup_choice', playerSelected)
        sic_respawnmenu.settitle('Respawn Menu')
        playerlist = playerlib.getPlayerList('#all')
        for player in playerlist:
             t_userid = int(player)
             t_name = player.get('name')
             sic_respawnmenu.addoption(t_userid, t_name)
        sic_respawnmenu.addoption("#t", "Terrorists")
        sic_respawnmenu.addoption("#c", "Counter-Terrorists")
        sic_respawnmenu.addoption("#d", "Dead Players")
        sic_respawnmenu.send(userid)
    else:
        es.tell(userid, '#multi','#greenYou are not authorized to run this command')

def playerSelected(caller, target, sic_respawnmenu):
    es.server.queuecmd('est_spawn %s 1'%target)
    respawnmenu()
    if respawnmenu_announce == 1:
        if target not in ['#c','#t','#d']:
            es.msg('#multi', '#green[Respawn Admin] #lightgreen %s #defaultrespawned #lightgreen%s' % (es.getplayername(caller), es.getplayername(target)))
        elif target == '#c':
              es.msg('#multi','#green[Respawn Admin] #lightgreen %s #defaultrespawned Counter-Terrorists' % es.getplayername(caller))
        elif target == '#t':
              es.msg('#multi','#green[Respawn Admin] #lightgreen %s #defaultrespawned Terrorists' % es.getplayername(caller))
        elif target == '#d':
              es.msg('#multi','#green[Respawn Admin] #lightgreen %s #defualtrespawned all Dead Players' % es.getplayername(caller))

def setup_auth():
    global isAuthed
    if services.isRegistered('auth'):
        auth_service = services.use('auth')
        auth_service.registerCapability('respawnmenu_admin', auth_service.ADMIN)
        isAuthed = lambda x: auth_service.isUseridAuthorized(x, 'respawnmenu_admin')
    else:
        isAuthed = lambda x: False